module AG1 where

-- import Trace
import UU_Pretty
import UU_Scanner
import AG1_Parser
import AG1_Print
import OldPretty

signOn           :: String
signOn            = "Mini Attribute Grammar System, SD Swierstra, Version 1.0, dd. 18-05-1998 \n"
tracelist [] = []
tracelist (a:as) = seq (show a == show a) (a:tracelist as)
-------------------------------------------------------------------------
-- Specialisation of Scanner
-------------------------------------------------------------------------
keywordstxt      = ["DATA", "EXTEND", "IN", "OUT", "INOUT", "LOCAL", "LHS", "SEM"]
keywordsops      = []
specialchars     = ".{};:[]=,|"
opchars          = "!#$%&*+/<=>?@\\^|-"

main      = do putStr signOn
               putStr "Type input <filename>.ag :"
               filename  <- getLine
               input     <- readFile (filename++".ag")
               let tokens  = tracelist (scanner keywordstxt 
                                                keywordsops 
                                                specialchars 
                                                opchars 
                                        input 1)
               let (res, rest, cfree_errors) = parser tokens []
               putStr cfree_errors
               (writeFile (filename++".hs"). display)  (printall res filename)
               putStr (filename++".hs" ++ " generated") 
